using System;
using System.Collections.Generic;
using System.Text;

using System.ComponentModel;

namespace DyamicPropertyDescriptorDemo {
	public class PersonCollection : List<Person>, ITypedList {
		protected IPersonViewBuilder _viewBuilder;

		public PersonCollection(IPersonViewBuilder viewBuilder) {
			_viewBuilder = viewBuilder;
		}

		#region ITypedList Members

		protected PropertyDescriptorCollection _props;

		public PropertyDescriptorCollection GetItemProperties(PropertyDescriptor[] listAccessors) {
			if (_props == null) {
				_props = _viewBuilder.GetView();
			}
			return _props;
		}

		public string GetListName(PropertyDescriptor[] listAccessors) {
			return ""; // was used by 1.1 datagrid
		}

		#endregion
	}
}
